diff --git a/test/unit/commands/update_test.rb b/test/unit/commands/update_test.rb
new file mode 100644
index 000000000..966af55bc
--- /dev/null
+++ b/test/unit/commands/update_test.rb
@@ -0,0 +1,191 @@
+require "test_helper"
+require "hive/channel"
+require "hive/commands/update"
+
+# U7 of the packaging plan: `hive update` upgrades through the channel
+# that installed hive, never swapping binaries itself.
+class UpdateTest < Minitest::Test
+  include HiveTestHelper
+
+  FakeStatus = Class.new do
+    def initialize(success) = @success = success
+    def success? = @success
+  end
+
+  def recording_runner(expected: nil)
+    commands = []
+    runner = lambda do |argv|
+      commands << argv
+      # Probe-style commands (pacman -Qo, command -v) report "not found"
+      # so channel detection stays deterministic unless a test overrides.
+      probe = argv.first == "pacman" || argv.first == "sh"
+      [ "", "", FakeStatus.new(!probe) ]
+    end
+    [ commands, runner ]
+  end
+
+  def failing_runner
+    ->(argv) { [ "", "nope", FakeStatus.new(false) ] }
+  end
+
+  # ── channel detection ─────────────────────────────────────────────────
+
+  def test_detect_brew_via_cellar_path
+    assert_equal :brew, Hive::Channel.detect(
+      bin_path: "/opt/homebrew/Cellar/hive/0.1.0/bin/hive",
+      runner: ->(argv) { raise "pacman must not run for brew paths" }
+    )
+  end
+
+  def test_detect_pacman_via_pacman_qo
+    pacman = ->(argv) { argv; [ "/extra/hive-bin 0.1.0-1\n", "", FakeStatus.new(true) ] }
+    assert_equal :pacman, Hive::Channel.detect(bin_path: "/usr/bin/hive", runner: pacman)
+  end
+
+  def test_detect_script_via_bundle_marker
+    with_tmp_dir do |dir|
+      bundle = File.join(dir, ".local", "opt", "hive", "0.1.0", "bin")
+      FileUtils.mkdir_p(bundle)
+      File.write(File.join(File.dirname(bundle), Hive::Channel::BUNDLE_MARKER), "0.1.0")
+      File.write(File.join(bundle, "hive"), "#!/bin/sh\n")
+
+      assert_equal :script, Hive::Channel.detect(
+        bin_path: File.join(bundle, "hive"),
+        runner: ->(argv) { argv; [ "", "", FakeStatus.new(false) ] }
+      )
+    end
+  end
+
+  def test_detect_unknown_when_nothing_matches
+    assert_equal :unknown, Hive::Channel.detect(
+      bin_path: "/usr/local/bin/hive",
+      runner: ->(argv) { argv; [ "", "", FakeStatus.new(false) ] }
+    )
+  end
+
+  def test_detect_refuses_ambiguous_channels
+    with_tmp_dir do |dir|
+      # A binary under a tmp-local "/cellar/" path that ALSO carries a
+      # bundle marker AND is pacman-owned → refuse to guess.
+      weird = File.join(dir, "opt", "homebrew", "Cellar", "hive", "0.1.0", "bin", "hive")
+      marker = File.join(dir, "opt", "homebrew", "Cellar", "hive", "0.1.0", Hive::Channel::BUNDLE_MARKER)
+      FileUtils.mkdir_p(File.dirname(weird))
+      File.write(marker, "0.1.0")
+      File.write(weird, "#!/bin/sh\n")
+      pacman = ->(argv) { argv; [ "", "", FakeStatus.new(true) ] }
+
+      assert_raises(Hive::Channel::AmbiguousChannel) do
+        Hive::Channel.detect(bin_path: weird, runner: pacman)
+      end
+    end
+  end
+
+  # ── upgrade commands per channel ──────────────────────────────────────
+
+  def test_upgrade_command_brew
+    assert_equal %w[brew upgrade hive], Hive::Channel.upgrade_command(:brew)
+  end
+
+  def test_upgrade_command_script_reruns_installer
+    command = Hive::Channel.upgrade_command(:script, repo: "acme/hive")
+    assert_equal "bash", command[0]
+    assert_includes command[2], "https://github.com/acme/hive/releases/latest/download/install.sh"
+  end
+
+  def test_update_runs_native_command_for_brew_channel
+    commands, runner = recording_runner
+    out = StringIO.new
+    result = Hive::Commands::Update.new(
+      bin_path: "/opt/homebrew/Cellar/hive/0.1.0/bin/hive",
+      runner: runner, output: out
+    ).call
+
+    assert_equal 0, result
+    upgrades = commands.reject { |argv| argv.first == "pacman" } # drop detect probes
+    assert_equal [ %w[brew upgrade hive] ], upgrades,
+                 "brew installs must upgrade via brew, never by copying binaries"
+    assert_includes out.string, "running: brew upgrade hive"
+  end
+
+  def test_update_dry_run_prints_without_executing
+    commands, runner = recording_runner
+    out = StringIO.new
+    result = Hive::Commands::Update.new(
+      bin_path: "/opt/homebrew/Cellar/hive/0.1.0/bin/hive",
+      runner: runner, output: out, dry_run: true
+    ).call
+
+    assert_equal 0, result
+    executed = commands.reject { |argv| argv.first == "pacman" } # drop detect probes
+    assert_empty executed, "--dry-run must not execute anything"
+    assert_includes out.string, "brew upgrade hive"
+  end
+
+  def test_update_uses_yay_when_available_for_pacman
+    commands = []
+    runner = lambda do |argv|
+      commands << argv
+      if argv.first == "sh"
+        # command -v yay probe → yay exists
+        [ "/usr/bin/yay\n", "", FakeStatus.new(true) ]
+      else
+        [ "", "", FakeStatus.new(true) ]
+      end
+    end
+    out = StringIO.new
+    result = Hive::Commands::Update.new(
+      bin_path: "/usr/bin/hive",
+      runner: runner, output: out
+    ).call
+
+    assert_equal 0, result
+    assert_includes commands, %w[yay -Syu hive-bin]
+  end
+
+  def test_update_prints_manual_hint_when_no_yay_and_never_runs_sudo
+    commands = []
+    runner = lambda do |argv|
+      commands << argv
+      if argv == %w[pacman] - [] || argv.first == "pacman"
+        [ "/extra/hive-bin 0.1.0-1\n", "", FakeStatus.new(true) ] # pacman owns it
+      elsif argv.first == "sh"
+        [ "", "", FakeStatus.new(false) ] # no yay on PATH
+      else
+        raise "must not run anything beyond probes without yay"
+      end
+    end
+    out = StringIO.new
+    result = Hive::Commands::Update.new(
+      bin_path: "/usr/bin/hive",
+      runner: runner, output: out
+    ).call
+
+    assert_equal 1, result
+    assert_includes out.string, "sudo pacman -Syu"
+    assert_includes out.string, "never runs sudo"
+    forbidden = commands.reject { |argv| argv.first == "sh" || argv.first == "pacman" }
+    assert_empty forbidden,
+                 "without yay, update must only probe — never run sudo/yay itself"
+  end
+
+  def test_update_unknown_channel_prints_manual_instructions
+    out = StringIO.new
+    result = Hive::Commands::Update.new(
+      bin_path: "/somewhere/random/bin/hive",
+      runner: ->(argv) { argv; [ "", "", FakeStatus.new(false) ] },
+      output: out
+    ).call
+
+    assert_equal 1, result
+    assert_includes out.string, "could not determine"
+  end
+
+  def test_update_surfaces_failing_native_command
+    assert_raises(Hive::Error) do
+      Hive::Commands::Update.new(
+        bin_path: "/opt/homebrew/Cellar/hive/0.1.0/bin/hive",
+        runner: failing_runner, output: StringIO.new
+      ).call
+    end
+  end
+end
diff --git a/test/unit/config_xdg_test.rb b/test/unit/config_xdg_test.rb
new file mode 100644
index 000000000..f7f7d737d
--- /dev/null
+++ b/test/unit/config_xdg_test.rb
@@ -0,0 +1,236 @@
+require "test_helper"
+require "hive/config"
+
+# U2 of the packaging plan: XDG layout migration for hive's GLOBAL files.
+# Per-project state (.hive-state/) is untouched by design — these tests
+# only cover path resolution for config / state / cache homes.
+class ConfigXDGTest < Minitest::Test
+  include HiveTestHelper
+
+  XDG_ENV_KEYS = %w[
+    HIVE_HOME HIVE_CONFIG_HOME HIVE_STATE_HOME HIVE_CACHE_HOME
+    XDG_CONFIG_HOME XDG_STATE_HOME XDG_CACHE_HOME
+  ].freeze
+
+  def with_clean_env(env = {})
+    old = {}
+    XDG_ENV_KEYS.each { |k| old[k] = ENV[k]; ENV.delete(k) }
+    env.each { |k, v| ENV[k] = v }
+    Hive::Config.migration_notice_printed = false
+    begin
+      yield
+    ensure
+      XDG_ENV_KEYS.each do |k|
+        if old[k].nil?
+          ENV.delete(k)
+        else
+          ENV[k] = old[k]
+        end
+      end
+      Hive::Config.migration_notice_printed = false
+    end
+  end
+
+  # ── config_home resolution ────────────────────────────────────────────
+
+  def test_config_home_defaults_to_xdg
+    with_clean_env do
+      assert_equal File.join(File.expand_path("~"), ".config/hive"), Hive::Config.config_home
+    end
+  end
+
+  def test_config_home_honours_xdg_config_home
+    with_clean_env("XDG_CONFIG_HOME" => "/xdg/cfg") do
+      assert_equal "/xdg/cfg/hive", Hive::Config.config_home
+    end
+  end
+
+  def test_config_home_honours_hive_config_home_over_everything
+    with_clean_env("XDG_CONFIG_HOME" => "/xdg/cfg", "HIVE_CONFIG_HOME" => "/custom") do
+      assert_equal "/custom", Hive::Config.config_home
+    end
+  end
+
+  def test_hive_home_keeps_dev_checkout_mode
+    with_tmp_dir do |dir|
+      with_clean_env("HIVE_HOME" => dir) do
+        assert Hive::Config.legacy_mode?
+        assert_equal dir, Hive::Config.config_home
+        assert_equal File.join(dir, "config.yml"), Hive::Config.global_config_path
+      end
+    end
+  end
+
+  def test_global_config_path_defaults_to_xdg_location
+    with_clean_env do
+      assert_equal File.join(File.expand_path("~"), ".config/hive/config.yml"),
+                   Hive::Config.global_config_path
+    end
+  end
+
+  def test_legacy_config_used_as_fallback_when_xdg_absent
+    with_tmp_dir do |dir|
+      legacy = File.join(dir, "Dev", "hive")
+      FileUtils.mkdir_p(legacy)
+      File.write(File.join(legacy, "config.yml"), { "registered_projects" => [] }.to_yaml)
+
+      with_clean_env("HOME" => dir) do
+        # HOME is not in XDG_ENV_KEYS; set it manually for the duration.
+        old_home = ENV["HOME"]
+        ENV["HOME"] = dir
+        begin
+          Hive::Config.migration_notice_printed = false
+          assert_equal File.join(legacy, "config.yml"), Hive::Config.global_config_path
+        ensure
+          ENV["HOME"] = old_home
+        end
+      end
+    end
+  end
+
+  def test_xdg_config_wins_over_legacy_when_present
+    with_tmp_dir do |dir|
+      xdg = File.join(dir, ".config", "hive")
+      legacy = File.join(dir, "Dev", "hive")
+      FileUtils.mkdir_p(xdg)
+      FileUtils.mkdir_p(legacy)
+      File.write(File.join(xdg, "config.yml"), { "registered_projects" => [] }.to_yaml)
+      File.write(File.join(legacy, "config.yml"), { "registered_projects" => [] }.to_yaml)
+
+      old_home = ENV["HOME"]
+      ENV["HOME"] = dir
+      begin
+        with_clean_env do
+          assert_equal File.join(xdg, "config.yml"), Hive::Config.global_config_path
+        end
+      ensure
+        ENV["HOME"] = old_home
+      end
+    end
+  end
+
+  # ── state_home / cache_home ───────────────────────────────────────────
+
+  def test_state_home_defaults_to_xdg_state
+    with_clean_env do
+      assert_equal File.join(File.expand_path("~"), ".local/state/hive"), Hive::Config.state_home
+    end
+  end
+
+  def test_state_home_honours_xdg_state_home
+    with_clean_env("XDG_STATE_HOME" => "/xdg/state") do
+      assert_equal "/xdg/state/hive", Hive::Config.state_home
+    end
+  end
+
+  def test_state_home_honours_hive_state_home
+    with_clean_env("HIVE_STATE_HOME" => "/custom/state") do
+      assert_equal "/custom/state/hive", Hive::Config.state_home
+    end
+  end
+
+  def test_state_home_stays_in_hive_home_in_dev_mode
+    with_tmp_dir do |dir|
+      with_clean_env("HIVE_HOME" => dir) do
+        assert_equal dir, Hive::Config.state_home
+      end
+    end
+  end
+
+  def test_cache_home_defaults_to_xdg_cache
+    with_clean_env do
+      assert_equal File.join(File.expand_path("~"), ".cache/hive"), Hive::Config.cache_home
+    end
+  end
+
+  # ── daemon pid/log placement ──────────────────────────────────────────
+
+  def test_daemon_pid_and_log_live_in_state_home_in_xdg_mode
+    with_clean_env("HIVE_STATE_HOME" => "/xdg/state") do
+      daemon = Hive::Commands::Daemon.new("status")
+      assert_equal "/xdg/state/hive/daemon.pid", daemon.pid_file
+      assert_equal "/xdg/state/hive/logs/daemon.log", daemon.log_file
+    end
+  end
+
+  def test_daemon_pid_and_log_stay_in_hive_home_in_dev_mode
+    with_tmp_dir do |dir|
+      with_clean_env("HIVE_HOME" => dir) do
+        daemon = Hive::Commands::Daemon.new("status", hive_home: dir)
+        assert_equal File.join(dir, ".daemon.pid"), daemon.pid_file
+        assert_equal File.join(dir, "logs", "daemon.log"), daemon.log_file
+      end
+    end
+  end
+
+  # ── bot defaults follow the state home ────────────────────────────────
+
+  def test_global_bot_defaults_use_state_home
+    with_clean_env("HIVE_STATE_HOME" => "/xdg/state") do
+      defaults = Hive::Config.global_bot_defaults
+      assert_equal "/xdg/state/hive/.bot.pid", defaults["pid_file"]
+      assert_equal "/xdg/state/hive/logs/bot.log", defaults["log_file"]
+    end
+  end
+
+  def test_global_bot_defaults_use_hive_home_in_dev_mode
+    with_tmp_dir do |dir|
+      with_clean_env("HIVE_HOME" => dir) do
+        defaults = Hive::Config.global_bot_defaults
+        assert_equal File.join(dir, ".bot.pid"), defaults["pid_file"]
+        assert_equal File.join(dir, "logs", "bot.log"), defaults["log_file"]
+      end
+    end
+  end
+
+  # ── migration notice ──────────────────────────────────────────────────
+
+  def test_migration_notice_printed_once_for_legacy_fallback
+    with_tmp_dir do |dir|
+      legacy = File.join(dir, "Dev", "hive")
+      FileUtils.mkdir_p(legacy)
+      File.write(File.join(legacy, "config.yml"), { "registered_projects" => [] }.to_yaml)
+
+      old_home = ENV["HOME"]
+      old_stderr = $stderr
+      ENV["HOME"] = dir
+      $stderr = StringIO.new
+      begin
+        with_clean_env do
+          Hive::Config.migration_notice_printed = false
+          Hive::Config.global_config_path
+          Hive::Config.global_config_path # second call — no repeat notice
+          out = $stderr.string
+          assert_includes out, "legacy global config"
+          assert_equal 1, out.scan("legacy global config").size,
+                       "migration notice must print exactly once per process"
+        end
+      ensure
+        ENV["HOME"] = old_home
+        $stderr = old_stderr
+      end
+    end
+  end
+
+  # ── registry round-trip through the XDG path ──────────────────────────
+
+  def test_register_project_writes_to_xdg_config_home
+    with_tmp_dir do |dir|
+      old_home = ENV["HOME"]
+      ENV["HOME"] = dir
+      begin
+        with_clean_env("HIVE_CONFIG_HOME" => File.join(dir, "cfg")) do
+          entry = Hive::Config.register_project(name: "demo", path: dir)
+          assert_equal "demo", entry["name"]
+          cfg_path = File.join(dir, "cfg", "config.yml")
+          assert File.exist?(cfg_path), "register_project must create the XDG config"
+          data = YAML.safe_load(File.read(cfg_path))
+          assert_equal [ "demo" ], data["registered_projects"].map { |p| p["name"] }
+          assert_equal [ entry ], Hive::Config.registered_projects
+        end
+      ensure
+        ENV["HOME"] = old_home
+      end
+    end
+  end
+end
diff --git a/test/unit/doctor_dependencies_test.rb b/test/unit/doctor_dependencies_test.rb
new file mode 100644
index 000000000..d49dc6290
--- /dev/null
+++ b/test/unit/doctor_dependencies_test.rb
@@ -0,0 +1,131 @@
+require "test_helper"
+require "stringio"
+require "json"
+require "hive/commands/doctor"
+
+# U10 of the packaging plan: install-aware `hive doctor` — required
+# (git, bash) vs recommended (claude, gh, jq, tmux) dependency reporting
+# with actionable per-OS install hints and distinct exit codes.
+class DoctorDependenciesTest < Minitest::Test
+  include HiveTestHelper
+
+  def base_config
+    {
+      "brainstorm" => { "agent" => "claude" },
+      "plan" => { "agent" => "claude" }
+    }
+  end
+
+  def probe(all_present: true)
+    Hive::Commands::Doctor::REQUIRED_TOOLS.product(
+      Hive::Commands::Doctor::RECOMMENDED_TOOLS
+    )
+    tools = Hive::Commands::Doctor::REQUIRED_TOOLS + Hive::Commands::Doctor::RECOMMENDED_TOOLS
+    tools.to_h { |t| [ t, all_present ] }
+  end
+
+  def run_doctor(probes, strict: false)
+    out = StringIO.new
+    doctor = Hive::Commands::Doctor.new(
+      config: base_config, project_root: nil,
+      json: true, output: out, strict: strict, probe_results: probes
+    )
+    # Skip tmux/skill checks by giving them injectable-friendly config:
+    # skill verification still probes the fake home; keep it simple by
+    # stubbing nothing — instead read rows directly.
+    exit_code = doctor.call
+    [ exit_code, JSON.parse(out.string), doctor ]
+  end
+
+  def with_green_skills
+    with_fake_home do |home|
+      write_file("#{home}/.claude/plugins/cache/mp/compound-engineering/3.0.1/skills/ce-brainstorm/SKILL.md")
+      write_file("#{home}/.claude/commands/plan.md")
+      yield home
+    end
+  end
+
+  def test_healthy_machine_exits_zero_with_all_dependencies_present
+    with_green_skills do
+      code, env = run_doctor(probe(all_present: true))
+      assert_equal 0, code
+      assert_equal 0, env["summary"]["missing_required"]
+      assert_equal 0, env["summary"]["missing_recommended"]
+    end
+  end
+
+  def test_missing_required_tool_exits_66
+    with_green_skills do
+      probes = probe(all_present: true)
+      probes["git"] = false
+      code, env = run_doctor(probes)
+      assert_equal Hive::Commands::Doctor::EXIT_MISSING_REQUIRED, code
+      assert_equal 1, env["summary"]["missing_required"]
+      row = env["checks"].find { |c| c["skill"] == "git" }
+      assert_equal "missing_required", row["status"]
+      assert_equal true, row["required"]
+      assert_includes row["message"], "REQUIRED"
+    end
+  end
+
+  def test_missing_recommended_tool_prints_hint_but_exits_zero_by_default
+    with_green_skills do
+      probes = probe(all_present: true)
+      probes["gh"] = false
+      probes["jq"] = false
+      code, env = run_doctor(probes)
+      assert_equal 0, code, "recommended-tool misses must not fail a default run"
+      assert_equal 2, env["summary"]["missing_recommended"]
+      row = env["checks"].find { |c| c["skill"] == "gh" }
+      assert_equal "missing_recommended", row["status"]
+      assert_equal false, row["required"]
+      assert_includes row["message"], "install gh"
+    end
+  end
+
+  def test_strict_mode_escalates_recommended_misses_to_67
+    with_green_skills do
+      probes = probe(all_present: true)
+      probes["tmux"] = false
+      code, _env = run_doctor(probes, strict: true)
+      assert_equal Hive::Commands::Doctor::EXIT_MISSING_RECOMMENDED, code
+    end
+  end
+
+  def test_required_miss_takes_precedence_over_skill_misses
+    with_fake_home do |_home|
+      # No skills installed at all → skill rows are missing (65-class);
+      # plus bash gone → required miss. Exit must be 66.
+      probes = probe(all_present: true)
+      probes["bash"] = false
+      code, _env = run_doctor(probes)
+      assert_equal Hive::Commands::Doctor::EXIT_MISSING_REQUIRED, code
+    end
+  end
+
+  def test_install_hints_are_per_os_family
+    doctor = Hive::Commands::Doctor.new(config: {}, project_root: nil)
+    hint = doctor.send(:install_hint, "git")
+    assert_kind_of String, hint
+    refute_empty hint
+  end
+
+  private
+
+  def with_fake_home(&block)
+    with_tmp_dir do |dir|
+      old = ENV["HOME"]
+      ENV["HOME"] = dir
+      begin
+        yield dir
+      ensure
+        old.nil? ? ENV.delete("HOME") : ENV["HOME"] = old
+      end
+    end
+  end
+
+  def write_file(path, content = "")
+    FileUtils.mkdir_p(File.dirname(path))
+    File.write(path, content)
+  end
+end
diff --git a/test/unit/init_service_test.rb b/test/unit/init_service_test.rb
new file mode 100644
index 000000000..eb88b87bf
--- /dev/null
+++ b/test/unit/init_service_test.rb
@@ -0,0 +1,142 @@
+require "test_helper"
+require "hive/commands/init"
+
+# U6: `hive init` offers one identical daemon-service prompt on both
+# platforms; non-TTY defaults to register-only; the skip flag prevents
+# registration entirely; backend failures never fail the init.
+class InitServiceTest < Minitest::Test
+  include HiveTestHelper
+
+  # Injectable fake for Init's `service:` collaborator. Records every
+  # install! call so tests can assert enable_and_start semantics.
+  class FakeService
+    attr_reader :install_calls
+
+    def initialize(platform:, skipped: false, installed: false, raise_on_install: false)
+      @platform = platform
+      @skipped = skipped
+      @installed = installed
+      @raise_on_install = raise_on_install
+      @install_calls = []
+    end
+
+    def skipped? = @skipped
+    def platform = @platform
+    def installed?(platform:) = @installed
+
+    def install!(**kw)
+      raise "boom" if @raise_on_install
+
+      @install_calls << kw
+      "/fake/unit/path"
+    end
+  end
+
+  def run_registration(dir, service)
+    out, err = with_captured_exit do
+      Hive::Commands::Init.new(dir, prompts: non_tty_prompts, service: service).maybe_register_service
+    end
+    [ out, err ]
+  end
+
+  def test_non_tty_init_registers_service_without_enabling
+    with_tmp_dir do |dir|
+      svc = FakeService.new(platform: :systemd)
+      capture_io { run_registration(dir, svc) }
+
+      assert_equal 1, svc.install_calls.size, "non-TTY must still register the unit (register-only)"
+      assert_equal false, svc.install_calls.first[:enable_and_start],
+                   "non-TTY must NEVER autostart the daemon"
+    end
+  end
+
+  def test_tty_yes_answer_enables_and_starts
+    with_tmp_dir do |dir|
+      svc = FakeService.new(platform: :systemd)
+      old_stdin = $stdin
+      $stdin = tty_string_io("y\n")
+      begin
+        capture_io { run_registration(dir, svc) }
+      ensure
+        $stdin = old_stdin
+      end
+
+      assert_equal 1, svc.install_calls.size
+      assert_equal true, svc.install_calls.first[:enable_and_start]
+    end
+  end
+
+  def test_tty_no_answer_registers_only
+    with_tmp_dir do |dir|
+      svc = FakeService.new(platform: :systemd)
+      old_stdin = $stdin
+      $stdin = tty_string_io("n\n")
+      begin
+        capture_io { run_registration(dir, svc) }
+      ensure
+        $stdin = old_stdin
+      end
+
+      assert_equal 1, svc.install_calls.size
+      assert_equal false, svc.install_calls.first[:enable_and_start], "decline path = register-only"
+    end
+  end
+
+  def test_none_platform_skips_entirely
+    with_tmp_dir do |dir|
+      svc = FakeService.new(platform: :none)
+      capture_io { run_registration(dir, svc) }
+
+      assert_empty svc.install_calls, ":none platform must not touch the service layer"
+    end
+  end
+
+  def test_already_installed_skips_reinstall
+    with_tmp_dir do |dir|
+      svc = FakeService.new(platform: :systemd, installed: true)
+      capture_io { run_registration(dir, svc) }
+
+      assert_empty svc.install_calls, "init must be idempotent when a unit already exists"
+    end
+  end
+
+  def test_skip_flag_prevents_registration
+    with_tmp_dir do |dir|
+      old = ENV["HIVE_SKIP_SERVICE_REGISTRATION"]
+      ENV["HIVE_SKIP_SERVICE_REGISTRATION"] = "1"
+      begin
+        svc = FakeService.new(platform: :systemd)
+        capture_io do
+          # Production path (no injected service) must honour the flag.
+          Hive::Commands::Init.new(dir, prompts: non_tty_prompts).maybe_register_service
+        end
+        assert_empty svc.install_calls
+      ensure
+        old.nil? ? ENV.delete("HIVE_SKIP_SERVICE_REGISTRATION") : ENV["HIVE_SKIP_SERVICE_REGISTRATION"] = old
+      end
+    end
+  end
+
+  def test_backend_failure_is_swallowed
+    with_tmp_dir do |dir|
+      svc = FakeService.new(platform: :systemd, raise_on_install: true)
+      _out, err = capture_io { run_registration(dir, svc) }
+      # The point of this test: no exception escapes init.
+      assert true
+    end
+  end
+
+  private
+
+  def non_tty_prompts
+    # Init#maybe_register_service never touches the prompts object; pass a
+    # minimal non-nil stand-in so construction stays cheap.
+    Hive::Commands::Init::Prompts.allocate
+  end
+
+  def tty_string_io(content)
+    io = StringIO.new(content)
+    def io.tty? = true
+    io
+  end
+end
diff --git a/test/unit/packaging/install_sh_test.rb b/test/unit/packaging/install_sh_test.rb
new file mode 100644
index 000000000..5f4c21cd6
--- /dev/null
+++ b/test/unit/packaging/install_sh_test.rb
@@ -0,0 +1,195 @@
+require "test_helper"
+require "digest"
+require "open3"
+require "tmpdir"
+require "fileutils"
+
+# U3 of the packaging plan: end-to-end runs of packaging/install.sh in a
+# sandboxed HOME with a stubbed `curl`, covering fresh install,
+# idempotent upgrade, the Apache-Hive `hv` collision fallback, hard
+# dependency failures, and checksum verification.
+class InstallShTest < Minitest::Test
+  include HiveTestHelper
+
+  REPO_ROOT = File.expand_path("../../..", __dir__)
+  INSTALL_SH = File.join(REPO_ROOT, "packaging", "install.sh").freeze
+  VERSION = "0.1.0".freeze
+
+  def setup_sandbox
+    Dir.mktmpdir("hive-install-test") do |home|
+      @home = home
+      @prefix = File.join(home, ".local")
+      @bin_dir = File.join(@prefix, "bin")
+      @fake_bin = File.join(home, "fake-bin")
+      FileUtils.mkdir_p([ @fake_bin, @bin_dir ])
+      build_fake_release
+      build_fake_curl
+      yield home
+    end
+  end
+
+  # Builds a fake release payload: tarball + SHA256SUMS + latest-release
+  # JSON, all served by the fake curl below.
+  def build_fake_release
+    platform = RUBY_PLATFORM.include?("darwin") ? "macos-arm64" : "linux-x86_64-gnu"
+    name = "hive-#{VERSION}-#{platform}"
+    bundle = File.join(@fake_bin, "payload", name)
+    FileUtils.mkdir_p(bundle)
+    File.write(File.join(bundle, ".hive-bundle"), "#{VERSION}\n")
+    File.write(File.join(bundle, "hive"), <<~SH)
+      #!/bin/bash
+      echo "hive #{VERSION}"
+    SH
+    File.chmod(0o755, File.join(bundle, "hive"))
+
+    tarball = File.join(@fake_bin, "payload", "#{name}.tar.gz")
+    system("tar", "-czf", tarball, "-C", File.dirname(bundle), name) || raise("tar failed")
+    @tarball_name = "#{name}.tar.gz"
+    @sha = Digest::SHA256.file(tarball).hexdigest
+    write_checksums(@sha)
+    File.write(File.join(@fake_bin, "payload", "latest.json"), '{"tag_name": "v' + VERSION + '"}')
+  end
+
+  def write_checksums(sha)
+    File.write(File.join(@fake_bin, "payload", "SHA256SUMS"), "#{sha}  #{@tarball_name}\n")
+  end
+
+  def build_fake_curl
+    File.write(File.join(@fake_bin, "curl"), <<~SH)
+      #!/bin/bash
+      # Minimal curl stub: handles -o <file> and treats the last arg as URL.
+      # Streams files directly — no command substitution, so binary payloads
+      # (the tarball) survive byte-for-byte.
+      out=""
+      args=("$@")
+      for i in "${!args[@]}"; do
+        if [[ "${args[$i]}" == "-o" ]]; then
+          out="${args[$((i+1))]}"
+        fi
+      done
+      url="${args[-1]}"
+      case "$url" in
+        */releases/latest)
+          src="#{@fake_bin}/payload/latest.json" ;;
+        *SHA256SUMS)
+          src="#{@fake_bin}/payload/SHA256SUMS" ;;
+        *#{@tarball_name})
+          src="#{@fake_bin}/payload/#{@tarball_name}" ;;
+        *)
+          echo "fake-curl: unexpected url $url" >&2; exit 22 ;;
+      esac
+      if [[ -n "$out" ]]; then
+        cat "$src" > "$out"
+      else
+        cat "$src"
+      fi
+    SH
+    File.chmod(0o755, File.join(@fake_bin, "curl"))
+  end
+
+  # A PATH dir mirroring the real system bins minus named tools, so
+  # `command -v <tool>` deterministically fails while everything else
+  # (uname, sed, grep, mktemp...) still works.
+  def stripped_bin_dir(without:)
+    dir = File.join(@home, "stripped-bin")
+    FileUtils.mkdir_p(dir)
+    [ "/usr/bin", "/bin" ].each do |src|
+      next unless File.directory?(src)
+
+      Dir.children(src).each do |entry|
+        next if without.include?(entry)
+        target = File.join(dir, entry)
+        next if File.exist?(target)
+
+        File.symlink(File.join(src, entry), target)
+      end
+    end
+    dir
+  end
+
+  def run_installer(env: {})
+    # Base PATH strips any pre-existing `hive` binary (this container has
+    # Apache Hive on PATH!) so the collision logic is deterministic.
+    # Computed lazily so an explicit PATH override (missing-git test) never
+    # populates the shared stripped dir with excluded tools.
+    full_env = { "HOME" => @home, "HIVE_PREFIX" => @prefix }.merge(env)
+    full_env["PATH"] ||= "#{@fake_bin}:#{stripped_bin_dir(without: %w[hive])}"
+    Open3.capture3(full_env, "bash", INSTALL_SH)
+  end
+
+  # ── scenarios ───────────────────────────────────────────────────────────
+
+  def test_fresh_install_creates_bundle_symlink_and_verifies_version
+    setup_sandbox do
+      out, err, status = run_installer
+
+      assert status.success?, "installer failed:\n#{out}\n#{err}"
+      assert_equal "#{VERSION}\n", File.read(File.join(@prefix, "opt/hive/#{VERSION}/.hive-bundle"))
+      assert File.exist?(File.join(@prefix, "opt/hive/current/hive"))
+      assert File.symlink?(File.join(@bin_dir, "hive"))
+      assert_includes out, "verification passed"
+    end
+  end
+
+  def test_rerun_upgrades_in_place_idempotently
+    setup_sandbox do
+      _out1, _err1, s1 = run_installer
+      assert s1.success?
+      out2, err2, s2 = run_installer
+      assert s2.success?, "second run must be an in-place upgrade:\n#{out2}\n#{err2}"
+      entries = Dir.children(File.join(@prefix, "opt/hive")).sort
+      assert_equal [ VERSION, "current" ], entries, "upgrade must not litter version dirs"
+    end
+  end
+
+  def test_hive_name_collision_installs_as_hv_and_warns_loudly
+    setup_sandbox do
+      # A foreign 'hive' earlier on PATH (e.g., Apache Hive).
+      File.write(File.join(@fake_bin, "hive"), "#!/bin/bash\necho apache-hive\n")
+      File.chmod(0o755, File.join(@fake_bin, "hive"))
+
+      out, _err, status = run_installer(env: { "PATH" => "#{@fake_bin}:#{stripped_bin_dir(without: [])}" })
+
+      assert status.success?
+      assert_includes out, "hv", "collision must be announced loudly"
+      refute File.symlink?(File.join(@bin_dir, "hive")), "must NOT clobber the existing hive command"
+      assert File.symlink?(File.join(@bin_dir, "hv")), "fallback launcher must be installed as hv"
+
+      link_target = File.readlink(File.join(@bin_dir, "hv"))
+      assert_includes link_target, "opt/hive/current/hive"
+    end
+  end
+
+  def test_missing_git_fails_with_hint_naming_package_manager_command
+    setup_sandbox do
+      stripped = stripped_bin_dir(without: %w[git])
+
+      _out, err, status = run_installer(env: { "PATH" => "#{@fake_bin}:#{stripped}" })
+
+      refute status.success?, "missing required tool must hard-fail"
+      assert_match(/missing required tool 'git'/, err)
+      assert_match(/apt-get|pacman|brew/, err, "failure must name a package-manager hint")
+      refute File.symlink?(File.join(@bin_dir, "hive")), "nothing may be installed on dependency failure"
+    end
+  end
+
+  def test_checksum_mismatch_refuses_install
+    setup_sandbox do
+      write_checksums(Digest::SHA256.hexdigest("bogus"))
+
+      _out, err, status = run_installer
+
+      refute status.success?
+      assert_match(/checksum verification FAILED/i, err)
+      refute File.symlink?(File.join(@bin_dir, "hive")), "nothing may be installed on checksum failure"
+    end
+  end
+
+  def test_pinned_version_env_is_honoured
+    setup_sandbox do
+      _out, _err, status = run_installer(env: { "HIVE_VERSION" => "v0.1.0" })
+      assert status.success?
+      assert File.directory?(File.join(@prefix, "opt/hive/0.1.0"))
+    end
+  end
+end
